/***********************************************************************
 *
 * int.h
 *
 ***********************************************************************
 *
 * interrupt management code
 *
 ***********************************************************************/

#ifndef INT_H_INCLUDED
#define INT_H_INCLUDED

/*
 * includes
 */

#include "std.h"
#include "intasm.h"

/*
 * defines
 */

/*
 * typedefs
 */

/*
 * structs
 */

/*
 * globals
 */

extern CIntArgs		*intArgs;
extern byte		*audioBuffers[2];

/*
 * function prototypes
 */

extern void	IntOpen(uint32 *code,int32 size);
extern void	IntClose(void);
extern void	IntStartAudio(int32 bufSize);
extern void	IntSubmitBuffer(int32 which);

#endif
