/************************************************************************
 *
 * intasm.h
 *
 ************************************************************************
 *
 * declarations for asm int handler
 *
 ************************************************************************/

#ifndef INTASM_H_INCLUDED
#define INTASM_H_INCLUDED

/*
 * includes
 */

#include "std.h"

/*
 * defines
 */

/*
 * structures/classes
 */

class CIntArgs
{
public:
	volatile int32		vbCount;
	volatile int32		dmaChannel;
	volatile uint32		dmaAddr0;
	volatile uint32		dmaAddr1;
	volatile uint32		dmaChain;
	volatile uint32		dmaEmpty;
	volatile int32		timerCt;
	volatile int32		dmaAttn;

	volatile int32		yMatchId;
	uint32			yMatchLine0,yMatchReg0;
	uint32			yMatchLine1,yMatchReg1;
	uint32			yMatchLine2,yMatchReg2;
};

/*
 * globals
 */

/*
 * prototypes
 */

extern int32		IntHandlerCode,IntHandlerArgs,IntHandlerEnd;

#endif
