/************************************************************************
 *
 * main.h
 *
 ************************************************************************
 *
 * miscellaneous support functions
 *
 ************************************************************************/

#ifndef MAIN_H_INCLUDED
#define MAIN_H_INCLUDED

/*
 * includes
 */

#include "std.h"

/*
 * defines
 */

#define FOON_VERSION		0x0016
#define SRAM_VERSION		0x0001
#define FOON_VERSION_STRING	"v0.22"

/*
 * structures/classes
 */

/*
 * globals
 */

/*
 * prototypes
 */

extern void		mymemcpy(void *a,void *b,int32 ct);
extern void		mymemset(void *a,byte v,int32 ct);
extern void		Call32(uint32 ad);
extern void		VideoInit(void);

#endif
