/************************************************************************
 *
 * std.h
 *
 ************************************************************************
 *
 * standard main include
 *
 ************************************************************************/

#ifndef STD_H_INCLUDED
#define STD_H_INCLUDED

/*
 * includes
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <math.h>

#ifdef WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#endif

/*
 * defines
 */

/*
 * typedefs
 */

typedef unsigned long	uint32;
typedef unsigned short	uint16;
typedef unsigned char	uint8;
typedef unsigned char	byte;

typedef signed long	int32;
typedef signed short	int16;
typedef signed char	int8;

typedef signed long	err32;

typedef signed char	bool8;

typedef void*		phandle;

/*
 * structures/classes
 */

/*
 * globals
 */

/*
 * prototypes
 */

#endif
