/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

#ifndef EMIT_H_INCLUDED
#define EMIT_H_INCLUDED

/*
 * includes
 */

#include "std.h"

/*
 * defines
 */

#define PREFIX_NONE		0x00
#define PREFIX_IX		0x01
#define PREFIX_IY		0x02

/*
 * typedefs
 */

class EmitDef
{
public:
	char		*name;
	void		(*emitFunc)(byte prefix,int32 a1,int32 a2,int32 a3);
};

/*
 * structs
 */

/*
 * globals
 */

extern EmitDef		emitDefs[];
extern EmitDef		asmEmitDefs[];
extern FILE		*wr;
extern int32		instNum;

extern char		*reg8StrNormal[];
extern char		*ireg8StrNormal[];
extern int32		extraClocks;

/*
 * function prototypes
 */

#endif
